//+------------------------------------------------------------------+
//|                                            MTF_MovingAverage.mq4 |
//|                                      Copyright ｩ 2006, Keris2112 |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Copyright ｩ 2006, Keris2112"
#property link      "http://www.forex-tsd.com"
#property strict
#property indicator_chart_window
#property indicator_buffers 6
#property indicator_color1 clrRoyalBlue
#property indicator_color2 clrRed
#property indicator_color3 clrRoyalBlue
#property indicator_color4 clrRed
#property indicator_color5 clrLimeGreen
#property indicator_color6 clrMagenta

//---- input parameters
/*************************************************************************
PERIOD_M1   1
PERIOD_M5   5
PERIOD_M15  15
PERIOD_M30  30
PERIOD_H1   60
PERIOD_H4   240
PERIOD_D1   1440
PERIOD_W1   10080
PERIOD_MN1  43200
You must use the numeric value of the timeframe that you want to use
when you set the TimeFrame' value with the indicator inputs.
---------------------------------------
PRICE_CLOSE    0 Close price.
PRICE_OPEN     1 Open price.
PRICE_HIGH     2 High price.
PRICE_LOW      3 Low price.
PRICE_MEDIAN   4 Median price, (high+low)/2.
PRICE_TYPICAL  5 Typical price, (high+low+close)/3.
PRICE_WEIGHTED 6 Weighted close price, (high+low+close+close)/4.
You must use the numeric value of the Applied Price that you want to use
when you set the 'applied_price' value with the indicator inputs.
---------------------------------------
MODE_SMA    0 Simple moving average,
MODE_EMA    1 Exponential moving average,
MODE_SMMA   2 Smoothed moving average,
MODE_LWMA   3 Linear weighted moving average.
You must use the numeric value of the MA Method that you want to use
when you set the 'ma_method' value with the indicator inputs.
**************************************************************************/
extern int TimeFrame 			= 0;
extern int MAPeriod 				= 13;
extern int ma_shift 				= 0;
extern int ma_method 			= MODE_SMA;
extern int applied_price 		= PRICE_CLOSE;

extern int Slow_MAPeriod 		= 16;
extern int Slow_ma_shift 		= 0;
extern int Slow_ma_method 		= MODE_SMA;
extern int Slow_applied_price	= PRICE_CLOSE;

extern bool SoundON 				= true;
extern bool EmailON 				= false;
extern bool LocalTimeMode  	= false;
extern bool QuickAlertMode 	= false;

double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];
double ExtMapBuffer4[];
double ExtMapBuffer5[];
double ExtMapBuffer6[];
int	 n = 0;
int	 prev_bars = 0;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
	string short_name, TimeFrameStr;
	//---- indicator line
	SetIndexBuffer(0, ExtMapBuffer1);
	SetIndexStyle(0, DRAW_LINE);
	SetIndexBuffer(1, ExtMapBuffer2);
	SetIndexStyle(1, DRAW_LINE);
	SetIndexBuffer(2, ExtMapBuffer3);
	SetIndexStyle(2, DRAW_ARROW, EMPTY, 0);
	SetIndexArrow(2, 161);
	SetIndexBuffer(3, ExtMapBuffer4);
	SetIndexStyle(3, DRAW_ARROW, EMPTY, 0);
	SetIndexArrow(3, 161);
	SetIndexBuffer(4, ExtMapBuffer5);
	SetIndexStyle(4, DRAW_LINE);
	SetIndexShift(4, 10);
	SetIndexBuffer(5, ExtMapBuffer6);
	SetIndexStyle(5, DRAW_LINE);
	SetIndexShift(5, 10);
	//---- name for DataWindow and indicator subwindow label
	switch (ma_method)
	{
		case 1 :
			short_name = "MTF_EMA(";
			break;
		case 2 :
			short_name = "MTF_SMMA(";
			break;
		case 3 :
			short_name = "MTF_LWMA(";
			break;
		default :
			short_name = "MTF_SMA(";
	}

	switch (TimeFrame)
	{
		case 1 :
			TimeFrameStr = "Period_M1";
			break;
		case 5 :
			TimeFrameStr = "Period_M5";
			break;
		case 15 :
			TimeFrameStr = "Period_M15";
			break;
		case 30 :
			TimeFrameStr = "Period_M30";
			break;
		case 60 :
			TimeFrameStr = "Period_H1";
			break;
		case 240 :
			TimeFrameStr = "Period_H4";
			break;
		case 1440 :
			TimeFrameStr = "Period_D1";
			break;
		case 10080 :
			TimeFrameStr = "Period_W1";
			break;
		case 43200 :
			TimeFrameStr = "Period_MN1";
			break;
		default :
			TimeFrameStr = "Current Timeframe";
	}

	IndicatorShortName(short_name + (string)MAPeriod + " " + (string)Slow_MAPeriod + ") " + TimeFrameStr);
	
	return (0);
}
//+------------------------------------------------------------------+
//|             MTF Moving Average                                   |
//+------------------------------------------------------------------+
int start()
{
	datetime TimeArray[];
	int i, j, y, limit, counted_bars = IndicatorCounted();
	// Plot defined timeframe on to current timeframe
	ArrayCopySeries(TimeArray, MODE_TIME, Symbol(), TimeFrame);
	
	if (prev_bars != Bars)
	{
		n = 0;
		prev_bars = Bars;
		
		for (i = 0; i < 100; i++)
		{
			ExtMapBuffer5[i] = EMPTY_VALUE;
			ExtMapBuffer6[i] = EMPTY_VALUE;
		}
	}
	
	if (counted_bars == 0)
		limit = Bars - (MAPeriod + Slow_MAPeriod);
	else
		limit = Bars - counted_bars + TimeFrame / Period();

	for (i = 0, y = 0; i < limit; i++)
	{
		if (Time[i] < TimeArray[y]) y++;

		/***********************************************************
		  Add your main indicator loop below.  You can reference an existing
		     indicator with its iName  or iCustom.
		  Rule 1:  Add extern inputs above for all neccesary values
		  Rule 2:  Use 'TimeFrame' for the indicator timeframe
		  Rule 3:  Use 'y' for the indicator's shift value
		**********************************************************/
		ExtMapBuffer1[i] = iMA(NULL, TimeFrame, MAPeriod, ma_shift, ma_method, applied_price, y) ;
		ExtMapBuffer2[i] = iMA(NULL, TimeFrame, Slow_MAPeriod, Slow_ma_shift, Slow_ma_method, Slow_applied_price, y) ;
	}

	for (i = 0; i < 100; i++)
	{
		if (ExtMapBuffer1[i] >= ExtMapBuffer2[i] && ExtMapBuffer1[i + 1] < ExtMapBuffer2[i + 1])
		{
			ExtMapBuffer3[i] = Low[i] - 3 * Point;
			
			if (n < 2)
			{
				for (j = 0; j <= i + 10; j++)
					ExtMapBuffer5[j] = Low[i];
				n++;
			}
		}
		else if (ExtMapBuffer1[i] <= ExtMapBuffer2[i] && ExtMapBuffer1[i + 1] > ExtMapBuffer2[i + 1])
		{
			ExtMapBuffer4[i] = High[i] + 5 * Point;
			
			if (n < 2)
			{
				for (j = 0; j <= i + 10; j++)
					ExtMapBuffer6[j] = High[i];
				n++;
			}
		}
		else
		{
			ExtMapBuffer3[i] = EMPTY_VALUE;
			ExtMapBuffer4[i] = EMPTY_VALUE;
		}
		
		if (n == 2)
			break;
	}

	datetime Current = TimeCurrent();

	if (LocalTimeMode == true) 
		Current = TimeLocal();

	int Target = 1;

	if (QuickAlertMode == true) 
		Target = 0;

	static datetime AlertTime = 0;

	if (ExtMapBuffer1[Target] >= ExtMapBuffer2[Target] && ExtMapBuffer1[Target + 1] < ExtMapBuffer2[Target] && AlertTime != Time[0])
	{
		if (SoundON) 
			Alert(Symbol() + (string)Period() + " BUY at ", Ask, "/", Bid, "  [", TimeToStr(Current, TIME_MINUTES) + "]   " + TerminalCompany());

		if (EmailON)
		{
			SendMail(Symbol() + (string)Period() + "BUY signal alert", Symbol() + (string)Period() + " BUY at Ask=" + DoubleToStr(Ask, Digits) 
						+ " Bid=" + DoubleToStr(Bid, Digits) + " [" + TimeToStr(Current, TIME_DATE | TIME_MINUTES) + "]");
		}

		AlertTime = Time[0];
	}

	if (ExtMapBuffer1[Target] <= ExtMapBuffer2[Target] && ExtMapBuffer1[Target + 1] > ExtMapBuffer2[Target] && AlertTime != Time[0])
	{
		if (SoundON) 
			Alert(Symbol() + (string)Period() + " SELL at ", Ask, "/", Bid, "  [", TimeToStr(Current, TIME_MINUTES) + "]   " + TerminalCompany());

		if (EmailON)
		{
			SendMail(Symbol() + (string)Period() + "SELL signal alert", Symbol() + (string)Period() + " SELL at Ask=" + DoubleToStr(Ask, Digits) 
						+ " Bid=" + DoubleToStr(Bid, Digits) + " [" + TimeToStr(Current, TIME_DATE | TIME_MINUTES) + "]");
		}

		AlertTime = Time[0];
	}

	return(0);
}
//+------------------------------------------------------------------+
